#include<bits/stdc++.h>

using namespace std;

class Line {
public:
    Line();
    void set(int x, int val);
    int getNextFreePos(int x);
    int get(int x);
private:
    static const int MAX_N = 100007;
    int nextFree[MAX_N];
    int values[MAX_N];
};

class UnionFind {
public:
    UnionFind();
    int findSet(int x);
    void mergeSet(int a, int b);
private:
    static const int MAX_N = 200007;
    int dad[MAX_N];
};

Line::Line() {
    for (int i = 0; i < MAX_N; ++i)
        nextFree[i] = i;
    for (int i = 0; i < MAX_N; ++i)
        values[i] = -1;
}

void Line::set(int x, int val) {
    nextFree[x] = nextFree[x+1];
    values[x] = val;
}

int Line::getNextFreePos(int x) {
    int me = x;
    int dad = nextFree[me];
    int grandDad;

    while (me != dad) {
        grandDad = nextFree[dad];
        nextFree[me] = grandDad;
        me = dad;
        dad = grandDad;
    }

    return me;
}

int Line::get(int x) {
    return values[x];
}

UnionFind::UnionFind() {
    for (int i = 0; i < MAX_N; ++i)
        dad[i] = i;
}

int UnionFind::findSet(int x) {
    int me = x;
    int daddy = dad[me];
    int grandDad;

    while (me != daddy) {
        grandDad = dad[daddy];
        dad[me] = grandDad;
        me = daddy;
        daddy = grandDad;
    }

    return me;
}

void UnionFind::mergeSet(int a, int b) {
    a = findSet(a);
    b = findSet(b);
    dad[b] = a;
}

const int MAX_Y = 99999;
int L;
vector<Line> table(50);
UnionFind unionFind;

int main() {
    cin >> L;

    for (int q = 0; q < L; ++q) {
        int t, x1, y1, x2, y2;
        cin >> t >> x1 >> y1 >> x2 >> y2;
        x1 -= 1;
        x2 -= 1;
        y1 -= 1;
        y2 -= 1;

        if (x1 > x2)
            swap(x1, x2);
        if (y1 > y2)
            swap(y1, y2);

        if (t == 0) {
            for (int x = x1; x <= x2; ++x) {
                int y = table.at(x).getNextFreePos(y1);

                while (y <= y2) {
                    table.at(x).set(y, q);
                    if (0 < y) {
                        int val = table.at(x).get(y-1);
                        if (val != -1)
                            unionFind.mergeSet(q, val);
                    }
                    if (y < MAX_Y) {
                        int val = table.at(x).get(y+1);
                        if (val != -1)
                            unionFind.mergeSet(q, val);
                    }
                    if (0 < x) {
                        int val = table.at(x-1).get(y);
                        if (val != -1)
                            unionFind.mergeSet(q, val);
                    }
                    if (x < table.size() - 1) {
                        int val = table.at(x+1).get(y);
                        if (val != -1)
                            unionFind.mergeSet(q, val);
                    }
                    y = table.at(x).getNextFreePos(y);
                }
            }
        }
        else { // t == 1
            int val1 = table.at(x1).get(y1);
            int val2 = table.at(x2).get(y2);

            if (val1 == -1 || val2 == -1) {
                cout << "0\n";
            } else if (unionFind.findSet(val1) == unionFind.findSet(val2)) {
                cout << "1\n";
            } else {
                cout << "0\n";
            }
        }
    }

}
